/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

#define TYP_NONE  -1

static Etype *type['z'-'a'+1];

implicit_init ()  /* sets default implicits */
{
	implicit_end ();
}

implicit_end ()  /* sets default implicits */
{
	implicit_set ('a', 'h', Etype_REAL_0);
	implicit_set ('i', 'n', Etype_INTEGER_0);
	implicit_set ('o', 'z', Etype_REAL_0);
};

Etype *implicit_get (id)  /* gets TYP_... given char *id */
char *id;
{
	char letter = id[0];
	Etype *etype;

	if (letter == '@')
		return Etype_INTEGER_0; /* avoids complications when setting the function value */

	if (letter == '_') {
		sprintf (serr, "need to give explicit type for '%s'", id);
		fatal (serr);
		return Etype_INTEGER_0;
	}

	if (isupper (letter))
		letter = tolower (letter);

	if ((etype = type [letter-'a']) == EN) {
		sprintf (serr, "variable '%s' not declared", id);
		fatal (serr);
		etype = Etype_INTEGER_0; /* to try to avoid a cascade of errors */
	}
	
	return etype;
}

Etype *implicit_get_for_external (id)  /* gets TYP_... given char *id */
char *id;
{
	char letter = id[0];
	Etype *etype;

	if (letter == '@')
		return Etype_INTEGER_0; /* avoids complications when setting the function value */

	if (letter == '_') {
		return Etype_INTEGER_0;
	}

	if (isupper (letter))
		letter = tolower (letter);

	if ((etype = type [letter-'a']) == EN) {
		if (letter >= 'i' && letter <= 'n')
			etype = Etype_INTEGER_0;
		else
			etype = Etype_REAL_0;
		
		sprintf (serr, "assuming that '%s' is a non-standard intrinsic of type %s"
		, id, etype_name (etype));
		warning (serr);
	}

	return etype;
}

implicit_set (from, to, as)  /* sets new implicits */
char from, to;
Etype *as;
{
	int i;

	if (isupper (from))
		from = tolower (from);

	if (isupper (to))
		to = tolower (to);

	for (i = from; i <= to; i++)
		type [i - 'a'] = as;
}

implicit_set_none ()  /* sets implicit none */
{
	implicit_set ('a', 'z', EN);
}

implicit_enddecl ()  /* set implicit for the variables without type */
{
	T_Entry *entry;
	
	for_TABLE_LOOP (entry)
		if (entry->typ == (Typ*) 0) {
			entry->typ = typ_malloc ();
			entry->typ->etype = implicit_get (entry->orig_name);
		}
		else if (entry->typ->etype == EN) {
			entry->typ->etype = implicit_get (entry->orig_name);
		}
}
